#include <bits/stdc++.h>
using namespace std;
#define int long long
#define dd long double

struct q {
    int qstart;
    int qfin;
    int qtype;
};

bool comp(q& x, q& y) {
    if (x.qtype == y.qtype) {
        return x.qfin <= y.qfin;
    } else if (x.qtype == -1) {
        return x.qstart >= y.qfin;
    } else {
        return x.qfin <= y.qstart;
    }
}

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<q> s;
    for (int i = 0; i < k; i++) {
        q now;
        int d, h, cmd;
        cin >> d >> h >> cmd;
        int st = d * 24 + h;
        now.qstart = st;
        now.qfin = st + m * 24;
        now.qtype = cmd;
        s.push_back(now);
    }
    sort(s.begin(), s.end(), comp);
    queue<q> a;
    queue<q> order;
    int tm = 0;
    int cnt1 = 0, cnt2 = 0;
    for (int i = 0; i < k; i++) {
        q cur = s[i];
        tm = cur.qstart;
        while (!order.empty() &&
            !a.empty() && a.front().qfin <= max(tm, order.front().qstart)) {
                a.pop();
                order.pop();
        }
        if (cur.qtype == -1) {
            order.push(cur);
        } else {
            if ((int)(a.size()) >= n) {
                cnt1++;
            } else {
                a.push(cur);
            }
        }
    }
    while (!order.empty() &&
        !a.empty() && a.front().qfin <= max(tm, order.front().qstart)) {
            a.pop();
            order.pop();
    }
    cnt2 = (int)(order.size());
    cout << cnt1 << '\n' << cnt2;
}

signed main() {
    solve();
}
