#include <bits/stdc++.h>
using namespace std;
#define int long long
#define dd long double

vector<int> CurDotStats;
vector<int> NextDotStats;
vector<pair<int, int>> tNo;
vector<pair<pair<int, int>, int>> tAnd;
set<int> OnlyFromDots;

void simulate() {
    NextDotStats.assign((int)(CurDotStats.size()), -1);
    for (int i = 0; i < (int)(tNo.size()); i++) {
        int come1 = tNo[i].first;
        int to = tNo[i].second;
        if (CurDotStats[come1] == 1) {
            NextDotStats[to] = max(NextDotStats[to], 0ll);
        } else {
            NextDotStats[to] = 1;
        }
    }
    for (int i = 0; i < (int)(tAnd.size()); i++) {
        int come1 = tAnd[i].first.first;
        int come2 = tAnd[i].first.second;
        int to = tAnd[i].second;
        if (CurDotStats[come1] == 1 && CurDotStats[come2] == 1) {
            NextDotStats[to] = 1;
        } else {
            NextDotStats[to] = max(NextDotStats[to], 0ll);
        }
    }
    if (!OnlyFromDots.empty()) {
        auto it = OnlyFromDots.begin();
        while (it != OnlyFromDots.end()) {
            NextDotStats[*it] = CurDotStats[*it];
            it++;
        }
    }
    CurDotStats = NextDotStats;
}

void solve() {
    int n;
    cin >> n;
    pair<int, int> Task;
    vector<pair<int, int>> PrevDots;
    for (int i = 0; i < n; i++) {
        int cmd;
        cin >> cmd;
        if (cmd == 0) {
            int k, x;
            cin >> k >> x;
            k--;
            PrevDots.push_back({k, x});
        } else if (cmd == 1) {
            int x, y;
            cin >> x >> y;
            x--, y--;
            tNo.push_back({x, y});
        } else if (cmd == 2) {
            int x, y, z;
            cin >> x >> y >> z;
            x--, y--, z--;
            tAnd.push_back({{x, y}, z});
        } else if (cmd == 3) {
            int k, t;
            cin >> k >> t;
            k--;
            Task = {k, t};
        }
    }
    sort(PrevDots.begin(), PrevDots.end());
    for (int i = 0; i < (int)(PrevDots.size()); i++) {
        CurDotStats.push_back(PrevDots[i].second);
    }
    NextDotStats.resize((int)(CurDotStats.size()));

    for (int i = 0; i < (int)(CurDotStats.size()); i++) {
        OnlyFromDots.insert(i);
    }
    for (int i = 0; i < (int)(tNo.size()); i++) {
        int to = tNo[i].second;
        if (OnlyFromDots.find(to) != OnlyFromDots.end()) {
            OnlyFromDots.erase(to);
        }
    }
    for (int i = 0; i < (int)(tAnd.size()); i++) {
        int to = tAnd[i].second;
        if (OnlyFromDots.find(to) != OnlyFromDots.end()) {
            OnlyFromDots.erase(to);
        }
    }
    for (int i = 0; i < Task.second; i++) {
        simulate();
        cout << CurDotStats[Task.first];
        if (i != Task.second - 1) cout << '\n';
    }
}

signed main() {
    solve();
}
