#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;

typedef long long ll;

int main() {
    int n;
    cin >> n;
    unordered_map <int, bool> points;
    vector <pair<int, int>> ne;
    vector <pair<pair<int, int>, int>> ae;
    int k = 0, t = 0;
    for (int i = 0; i < n; ++i){
        int v;
        cin >> v;
        if (v == 0){
            int m, n;
            cin >> m >> n;
            points[m] = n;
        }
        if (v == 1){
            int x, y;
            cin >> x >> y;
            ne.push_back({x, y});
        }
        if (v == 2){
            int x, y, z;
            cin >> x >> y >> z;
            ae.push_back({{x, y}, z});
        }
        if (v == 3){
            cin >> k >> t;
        }
    }
    int curt = 0;
    while (curt < t){
        unordered_map <int, bool> npoints;
        for (auto p : ne)
            npoints[p.second] |= !points[p.first];
        for (auto p : ae)
            npoints[p.second] |= points[p.first.first] && points[p.first.second];
        for (auto p : points)
            if (npoints.find(p.first) == npoints.end())
                npoints[p.first] = p.second;
        points = npoints;
        curt++;
        cout << points[k] << '\n';
    }
}