﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#define int long long
#define sz(x) (int)x.size()
#define forn(i, s, f) for(int i = 0; i < (int)f; ++i)

using namespace std;

const int inf = 1e9, N = 105;

vector<pair<int, int>> gr[N];
vector<bool> val(N);
vector<vector<int>> sost(N);

/*
6

0 1 1

0 2 0

0 3 0

1 2 3

2 1 3 2

3 3 5
*/

void solve() {
    int m = 0, K = 0, T = 0, n = 0;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        if (t == 0) {
            int v;
            bool c;
            cin >> v >> c;
            val[v] = c;
            n++;
        }
        else if (t == 1) {
            int x, y;
            cin >> x >> y;
            gr[x].push_back({ y, 0 });
        }
        else if (t == 2) {
            int x, y, z;
            cin >> x >> y >> z;
            gr[x].push_back({ z, y });
            gr[y].push_back({ z, x });
        }
        else {
            cin >> K >> T;
        }
    }
    for (int t = 0; t < T; ++t) {
        sost.assign(n + 1, {});
        for (int v = 1; v <= n; ++v) {
            for (auto to : gr[v]) {
                int u = to.first, v2 = to.second;
                if (v2 == 0) {
                    sost[u].push_back(!val[v]);
                }
                else if (v2 > v) {
                    sost[u].push_back(val[v] & val[v2]);
                }
            }
        }
        /*cout << "AA: ";*/
        for (int v = 1; v <= n; ++v) {
            if (sost[v].empty()) continue;
            bool one = 0;
            for (auto el : sost[v]) {
                if (el == 1) one = 1;
            }
            val[v] = one;
        }
        /*for (int v = 1; v <= n; ++v) cout << val[v] << " ";
        cout << endl;*/
        cout << val[K] << '\n';
    }
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}