dict_of_nodes = {}


class NotOperator:
    def __init__(self, par: int, ch: int):
        self.parent_node = par
        self.child_node = ch

    def apply(self):
        dict_of_nodes[self.child_node].res.append(not bool(dict_of_nodes[self.parent_node].state))


class AndOperator:
    def __init__(self, par1: int, par2: int, ch: int):
        self.parent_node_1 = par1
        self.parent_node_2 = par2
        self.child_node = ch

    def apply(self):
        dict_of_nodes[self.child_node].res.append(bool(dict_of_nodes[self.parent_node_1].state)
                                                  and bool(dict_of_nodes[self.parent_node_2].state))


class Node:
    def __init__(self, n: int, st: int):
        self.num = n
        self.state = st
        self.next_operator = None
        self.res = []


n = int(input())
k = 0
t = 0
for i in range(n):
    nums = list(map(int, input().split()))
    if nums[0] == 0:
        dict_of_nodes[nums[1]] = Node(nums[1], nums[2])
    elif nums[0] == 1:
        op = NotOperator(nums[1], nums[2])
        dict_of_nodes[nums[1]].next_operator = op
    elif nums[0] == 2:
        op = AndOperator(nums[1], nums[2], nums[3])
        dict_of_nodes[nums[1]].next_operator = op
    else:
        k = nums[1]
        t = nums[2]

for i in range(t):
    for nd in sorted(dict_of_nodes.keys()):
        if dict_of_nodes[nd].next_operator:
            dict_of_nodes[nd].next_operator.apply()
    for nd in dict_of_nodes.values():
        if nd.res:
            nd.state = any(nd.res)
            nd.res.clear()
    print(int(dict_of_nodes[k].state))

"""
6
0 1 1
0 2 0
0 3 0
1 2 3
2 1 3 2
3 3 5
"""
