#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using db = long double;

ll LNF = 1e18 + 1;


template <typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& x : a) in >> x;
    return in;
}

template <typename T>
istream& operator>>(istream& in, pair<T, T>& a) {
    in >> a.first >> a.second;
    return in;
}


string SEP = " ";

template <typename T>
ostream& operator<<(ostream& out, vector<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}

template <typename T>
ostream& operator<<(ostream& out, set<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}

template <typename T>
ostream& operator<<(ostream& out, multiset<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}




void SLN() {
    int n;
    cin >> n;
    ll ans = 0;
    ll last = -1;
    for (int i = 0; i < n; ++i) {
        ll x; cin >> x;
        while (x > 0) {
            if ((x % 13) % 6 == 0) {
                if (last != x % 13) ++ans;
                last = x % 13;
            }
            x /= 13;
        }
    }
    cout << ans;
}




void IOF() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
}


signed main() {
    IOF();

    int T = 1;
    //cin >> T;
    while (T--) {
        SLN();
        cout << '\n';
    }

    exit('U' ^ 'U');
}
