// Generated at 2024.03.09 09:48:34
// Contest name - tinkoff - 24.03.09 швб
// Problem B

#include <iostream>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;
const int INF = 1e12 + 3037;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int n, m, k; cin >> n >> m >> k;
    vector<pair<int, int>> v(n, {0, 0});
    vector<pair<int, int>> q(k);
    for (int i = 0; i < k; ++i) {
        int d, h, t; cin >> d >> h >> t;
        h += (d - 1) * 24;
        q[i] = {h, t};
    }
    sort(q.begin(), q.end());
    int no_free = 0;
    vector<int> fl;
    for (int j = 0; j < k; ++j) {
        int h = q[j].first;
        int t = q[j].second;

        if (t == 1) {
            bool flag = false;
            int ind;
            for (int i = 0; i < n; ++i) {
                if (v[i].first <= h && v[i].second == 0) {
                    v[i].first = h + m * 24;
                    v[i].second = 1;
                    ind = i;
                    flag = true;
                    break;
                }
            }

            if (!flag) {
                no_free++;
            } else {
                if (!fl.empty()) {
                    v[ind].second = 0;
                }
            }
        } else {
            bool flag = false;
            int mn = INF;
            int mn_elem;
            for (int i = 0; i < n; ++i) {
                if (v[i].second == 1) {
                    if (mn > v[i].first) {
                        mn = v[i].first;
                        mn_elem = i;
                    }
                    flag = true;
                }
            }

            if (!flag) {
                fl.push_back(h);
            } else {
                v[mn_elem].second = 0;
            }
        }
    }

    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (v[i].second == 1) {
            cnt++;
        }
    }

    cout << no_free << '\n' << max((int)fl.size() - cnt, 0ll) << '\n';
    return 0;
}
