// Generated at 2024.03.09 09:48:34
// Contest name - tinkoff - 24.03.09 швб
// Problem C

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#define int long long

using namespace std;
const int INF = 1e12 + 3037;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int l, r; cin >> l >> r;
    set<int> prime;
    vector<bool> used(r + 1, false);
    for (int i = 2; i <= r; ++i) {
        if (!used[i]) {
            prime.insert(i);
            for (int j = i * 2; j <= r; j += i) {
                used[j] = true;
            }
        }
    }

    int mn = INF;
    int mn_elem;
    for (int i = l; i <= r; ++i) {
        if (i % 2 != 0 || i == 2) { continue; }
        int tmp = 0;
        for (auto x : prime) {
            if (x > i) { continue; }
            if (i - x != 1 && prime.find(i - x) != prime.end()) {
                tmp++;
                if (x == i - x) {
                    tmp++;
                }
            }
        }

        tmp /= 2;
        if (tmp % 5 == 0) {
            if (tmp < mn) {
                mn = tmp;
                mn_elem = i;
            }
        }
    }


    if (mn == INF) {
        cout << "Impossible" << '\n';
    } else {
        cout << mn_elem << " " << mn << '\n';
    }
    return 0;
}
