n, m, k = map(int, input().split())

journal = sorted([tuple(map(int, input().split())) for _ in range(k)])


def is_ready(day_cur, hour_cur, on_ship):
    for d, h in on_ship:
        if (day_cur - d)*24 + hour_cur - h >= 24*m:
            return True
    return False

def get_ready_on_hour(d, h):
    on_ship = []
    planned = 0
    for day, hour, action in filter(lambda x: (d, h, -1) > x, journal):
        for _ in range(planned):
            if on_ship and is_ready(day, hour, on_ship):
                on_ship.pop(0)
                planned -= 1
        if action == 1:
            if len(on_ship) < n and (d - day)*24 + h - hour >= 24*m:
                on_ship.append((day, hour))
        else:
            if on_ship and is_ready(day, hour, on_ship):
                on_ship.pop(0)
            else:
                planned += 1

    for _ in range(planned):
        if on_ship and is_ready(day, hour, on_ship):
            on_ship.pop(0)
            planned -= 1

    return len(on_ship)


def main():
    on_board = 0
    otklon = 0
    planned_out = 0

    for day, hour, action in journal:
        for _ in range(planned_out):
            if get_ready_on_hour(day, hour):
                planned_out -= 1

        if action == 1:
            if on_board < n:
                on_board += 1
            else:
                otklon += 1
        else:
            if get_ready_on_hour(day, hour):
                on_board -= 1
            else:
                planned_out += 1

    print(otklon)
    print(planned_out)


main()
