#include "bits/stdc++.h"

using namespace std;

struct Event
{
    int hour, type;
};

bool operator<(const Event &a, const Event &b) {
    if(a.hour == b.hour) {
        return a.type < b.type;
    } else {
        return a.hour < b.hour;
    }
}


int main() {
    int n, m, k;

    cin >> n >> m >> k;

    vector<int> state(n);
    vector<bool> used(n);

    vector<Event> timeline(k);

    for (size_t i = 0; i < k; i++)
    {
        int day, hour, type;

        cin >> day >> hour >> type;

        hour += (day - 1) * 24;

        timeline[i].hour = hour;
        timeline[i].type = type;
    }

    sort(timeline.begin(), timeline.end());

    int vilet_wait = 0;
    int rejected = 0;

    int cur_event = 0;


    for(int i = 0; i <= timeline[timeline.size()-1].hour; i++) {
        
        if(timeline[cur_event].hour > i) {
            for (size_t j = 0; j < n; j++)
            {
                if(used[j]) {
                    state[j]--;
                }
            }

            if (vilet_wait > 0) {
                for (size_t j = 0; j < n; j++)
                {
                    if(used[j] && state[j] <= 0 && vilet_wait > 0) {
                        used[j] = false;
                        state[j] = 0;
                        vilet_wait--;
                    }
                }
            }
        } else {
            while (cur_event <= k-1 && timeline[cur_event].hour == i)
            {
                if(timeline[cur_event].type == -1) {
                    bool flag = false;

                    for (size_t j = 0; j < n; j++)
                    {
                        if(used[j] && state[j] <= 0) {
                            used[j] = false;
                            state[j] = 0;
                            flag = true;
                            break;
                        }
                    }
                    
                    if(!flag) {
                        vilet_wait++;
                    }
                } else {
                    bool flag = false;

                    for (size_t j = 0; j < n; j++)
                    {
                        if(!used[j]) {
                            used[j] = true;
                            state[j] = m;
                            flag = true;
                            break;
                        }
                    }
                    
                    if(!flag) {
                        rejected++;
                    }
                }
                cur_event++;
            }

            if(cur_event > k-1){
                break;
            }
        }

    }

    cout << rejected << endl << vilet_wait << endl;
}