#include "bits/stdc++.h"

using namespace std;

enum Types {
    LogicNot,
    LogicAnd
};

struct Element
{
    int in1, in2, out;
    Types type;

    Element(Types type, int in1, int in2, int out) {
        this->in1 = in1;
        this->in2 = in2;
        this->out = out;
        this->type = type;
    }
};


int main() {
    int n;

    cin >> n;

    vector<bool> state(n+2);
    vector<Element> elements;

    int kk, kt;

    for (size_t i = 0; i < n; i++)
    {
        int type, out;

        cin >> type;

        switch (type)
        {
        case 0:
            int indx, val;
            cin >> indx >> val;
            state[indx - 1] = val;
            break;
        case 1:
            int in;
            cin >> in >> out;
            in--; out--;
            elements.push_back(Element{Types::LogicNot, in, -1, out});
            break;
        case 2:
            int in1, in2;
            cin >> in1 >> in2 >> out;
            in1--; in2--; out--;
            elements.push_back(Element{Types::LogicAnd, in1, in2, out});
            break;
        case 3:
            cin >> kk >> kt;
            break;
        }
    }    


    for (size_t t = 0; t < kt; t++)
    {
        vector<bool> state_t = state;
        vector<bool> changed_mask(n, false);

        for (size_t i = 0; i < elements.size(); i++)
        {
            if (elements[i].type == Types::LogicAnd) {
                bool result = state[elements[i].in1] && state[elements[i].in2];

                if (changed_mask[elements[i].out]) {
                    state_t[elements[i].out] = state_t[elements[i].out] || result;
                } else {
                    state_t[elements[i].out] = result;
                    changed_mask[elements[i].out] = true;
                }
            } else {
                bool result = !state[elements[i].in1];

                if (changed_mask[elements[i].out]) {
                    state_t[elements[i].out] = state_t[elements[i].out] || result;
                } else {
                    state_t[elements[i].out] = result;
                    changed_mask[elements[i].out] = true;
                }
            }
        }

        state = state_t;
        cout << state[kk-1] << endl;
    }
}