def gcd(a, b):
    if not b:
        return a
    return gcd(b, a % b)

def is_prime(n):
    if n == 1:
        return False

    for i in range(2, int(n ** 0.5) + 1):
        if gcd(n, i) != 1:
            return False
    return True

def g(n):
    c = 0
    for i in range(1, n // 2):
        if is_prime(i) and is_prime(n - i):
            c += 1
    return c


a, b = map(int, input().split())
x, gx = 0, 10 ** 6

for i in range(a, b + 1):
    if i % 2 == 0:
        gi = g(i)
        if gi > 0 and gi % 5 == 0 and gi < gx:
            x, gx = i, gi

if gx < 10 ** 6:
    print(x, gx)
else:
    print("Impossible")