﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <list>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <stack>
#include <numeric>
#include <map>
#include <string>
#include <sstream>
#include <iomanip>
#include <ios>
#include <ctime>
#include <chrono>
#include <random>

using namespace std;
typedef long long ll;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

#pragma warning(disable:4996)

set<int> primes;
char sieve[1000100];

void initSieve() {
    for (int i = 2; i < 1000100; ++i) {
        if (sieve[i] == 0) {
            primes.insert(i);
            for (int j = 2 * i; j < 1000100; j += i) {
                sieve[j] = 1;
            }
        }
    }
}

int g(int x) {
    int ans = 0;
    for (int e : primes) {
        if (2 * e > x) break;
        if (primes.find(x - e) != primes.end()) ans += 1;
    }
    return ans;
}

int main(){
    initSieve();
    int a, b; cin >> a >> b;
    vector<int> G(b + 1, 1e9);
    int max5 = -1;
    for (int i = a + (a & 1); i <= b; i += 2) {
        int u = g(i);
        if (u % 5 == 0) G[i] = u;
    }
    auto iter = min_element(G.begin(), G.end());
    if (*iter != 1e9) cout << iter - G.begin() << ' ' << *iter;
    else cout << "Impossible\n";
}

