﻿#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <fstream>
#include <numeric>
using namespace std;
using ll = long long;

struct ship {
	ll day, hour, type, overall = 0;
};

bool comp(ship a, ship b) {

	return (a.day < b.day || (a.day == b.day && a.hour < b.hour || a.day == b.day && a.hour == b.hour && a.type < b.type));
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//	ifstream in("in.txt");
	//	ofstream out("out.txt");
	ll n, m, k, day, day1, hour, hour1, type, otkaz = 0, waiting = 0;
	cin >> n >> m >> k;
	m *= 24;
	vector<ship> angar(0), ready(0), q(k);
	for (ll i = 0; i < k; i++) {
		cin >> q[i].day >> q[i].hour >> q[i].type;
	}
	sort(q.begin(), q.end(), comp);
	day1 = q[0].day;
	hour1 = q[0].hour;
	for (ll i = 0; i < k; i++) {
		// в ангар
		if (q[i].type == 1 && angar.size() + ready.size() < n) {
			angar.emplace_back(q[i]);
		}
		else if (q[i].type == 1 && angar.size() + ready.size() >= n) { 		// ОТКАЗ
			otkaz++;
		}
		else if (q[i].type == -1 && ready.size() >= 1) { // отправка судна
			ready.erase(ready.begin());
		}
		else if (q[i].type == -1 && ready.size() == 0) {
			waiting++;
		}
		if (i != k - 1) {
			for (ll p = q[i].day * 24 + q[i].hour; p <= q[i + 1].day * 24 + q[i + 1].hour; p++) {
				for (ll z = 0; z < ready.size(); z++) {
					ready[z].overall++;
				}
				for (ll z = 0; z < angar.size(); z++) {
					angar[z].overall++;
					if (angar[z].overall == m) {
						ready.emplace_back(angar[z]);
						angar.erase(angar.begin() + z);
					}
				}
			}
		}
		
	}
	ll otklon = ready.size() + angar.size() - waiting;
	otklon = abs(otklon);
	cout << otkaz << "\n" << otklon;
}
