#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    multiset<vector<int>> events;
    int waiting = 0;
    int preparing = 0;
    int ready = 0;
    int declined = 0;
    for (int i = 0; i < k; i++) {
        int d, h, t;
        cin >> d >> h >> t;
        events.insert({d, h, t});
    }

    for (vector<int> ev : events) {
        if (ev[2] == -2) {
            preparing--;
            if (waiting > 0) {
                waiting--;
                continue;
            }
            ready++;
            continue;
        }

        if (ev[2] == 1) {
            if (preparing + ready == n) {
                declined++;
                continue;
            }
            preparing++;
            events.insert({ev[0] + m, ev[1], -2});
            continue;
        }

        if (ready == 0) {
            waiting++;
            continue;
        }
        ready--;
    }
    cout << declined << endl << waiting << endl;
    return 0;
}