#include <iostream>
#include <vector>
#include <map>

using namespace std;

struct Logic {
    int type;
    int left;
    int right;
    int to;
};

int main() {
    int n;
    cin >> n;
    map<int, bool> g;
    map<int, int> upd;
    vector<Logic> logics;
    int K = -1, T = -1;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 0) {
            int m, st;
            cin >> m >> st;
            g[m] = st;
            continue;
        }
        if (t == 1) {
            int x, y;
            cin >> x >> y;
            logics.push_back({1, x, 0, y});
            continue;
        }
        if (t == 2) {
            int x, y, z;
            cin >> x >> y >> z;
            logics.push_back({2, x, y, z});
            continue;
        }
        cin >> K >> T;
    }
    if (T == -1) return 0;
    for (int i = 0; i < T; i++) {
        map<int, int> ng;
        for (auto p : g) ng[p.first] = p.second;
        for (auto & lgc : logics) {
            if (upd[lgc.to] == i + 1 && g[lgc.to] == 1) continue;
            upd[lgc.to] = i + 1;
            if (lgc.type == 1) {
                g[lgc.to] = !ng[lgc.left];
                continue;
            }
            g[lgc.to] = ng[lgc.left] && ng[lgc.right];
        }
        cout << g[K] << endl;
    }
}