#include <iostream>
#include "vector"
#include "map"
#include "string"
#include "algorithm"
#include <set>
#include "queue"

#define int int64_t

using namespace std;

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    int n; cin >> n;
    map<int, pair<bool, int>> points;
    vector <pair<int, int>> nots;
    vector <pair<pair<int, int>, int>> ands;
    vector<int> numbers;
    pair<int, int> problem;
    for (int i = 0; i < n; ++i) {
        int type; cin >> type;
        if (type == 0) {
            int num, on; cin >> num >> on;
            points[num] = {on, -1};
            numbers.push_back(num);
        } else if (type == 1) {
            int n1, n2; cin >> n1 >> n2;
            nots.push_back({n1, n2});
        } else if (type == 2) {
            int n1, n2, exit; cin >> n1 >> n2 >> exit;
            ands.push_back({{n1, n2}, exit});
        } else {
            cin >> problem.first >> problem.second;
        }
    }
    for (int i = 0; i < problem.second; ++i) {
        for (auto e : nots) {
            //points[e.second].second = !points[e.first].first;
            if (points[e.second].second == -1) points[e.second].second = !points[e.first].first;
            else points[e.second].second = (!points[e.first].first | points[e.second].second);
        }
        for (auto e : ands) {
            //points[e.second].second = points[e.first.first].first & points[e.first.second].first;
            if (points[e.second].second == -1) points[e.second].second = points[e.first.first].first & points[e.first.second].first;
            else points[e.second].second = ((points[e.first.first].first & points[e.first.second].first) | points[e.second].second);
        }
        for (auto e : numbers) {
            if (points[e].second != -1) {
                points[e].first = points[e].second;
                points[e].second = -1;
            }
            if (e == problem.first) cout << points[e].first << '\n';
        }
    }
}