#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops,O3")

typedef long long ll;
using namespace std;
const ll MAXN = 1e6;

ll is_prime(ll n) {
    ll d = 2;
    while (d * d <= n && n % d != 0) d++;
    return (ll)(d * d > n);
}

ll primes[MAXN + 1];

ll get_g(ll n) {
    ll g = 0;
    for (ll i = 3; i <= n / 2; i += 2) {
        if (primes[i] && primes[n - i]) g++;
    }
    return g;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll a, b, ans = -1, g_ans = -1, gt;
    cin >> a >> b;
    for(ll i = 2; i < MAXN; ++i) {
        primes[i] = is_prime(i);
    }
    a = a + a % 2;
    for (ll i = a; i <= b; i += 2) {
        gt = get_g(i);
        if (gt % 5 == 0 && (ans == -1 || g_ans > gt)) {
            ans = i;
            g_ans = gt;
        }
    }
    if (ans == -1) {
        cout << "Impossible";
    } else {
        cout << ans << " " << g_ans;
    }
    return 0;
}
