def check(angar, day, time, delay):
    if delay == 0: return angar, delay
    for i in range(len(angar)):
        if angar[i] != 'nope' and angar[i] >= 0:
            angar[i] = 'nope'
            delay -= 1
    return angar, delay

def increase(angar):
    for i in range(len(angar)):
        if angar[i] != 'nope':
            angar[i] += 1
    return angar

def mas_sort(x):
    return x[0], x[1], x[2]

n, m, k = map(int, input().split())
mas = []
for i in range(k):
    day, hour, comm = map(int, input().split())
    mas.append([day, hour, comm])
mas.sort(key = lambda x: mas_sort(x))
#сортируем массив по времени прибытия кораблей
#и порядку поступления команды (сначала вылетают, потом залетают)
angar = ['nope' for i in range(n)] #создаём "ангар"
day, time = 1, 0 #начало отсчёта времени
out, delay = 0, 0
while mas != []:
    angar, delay = check(angar, day, time, delay) #проверяем ангар на задержанные рейсы
    if day == mas[0][0] and time == mas[0][1] and mas[0][2] == 1: #заявка на залёт
        a = mas.pop(0)
        for i in range(n):
            if angar[i] == 'nope':
                angar[i] = -m #запускаем цикл, время ставим отрицательное
                break
        else: #мест нет
            out += 1
        continue
    elif day == mas[0][0] and time == mas[0][1] and mas[0][2] == -1: #заявка на вылет
        max_num = -2**32
        a = mas.pop(0)
        for i in range(len(angar)):
            if angar[i] != 'nope' and angar[i] > max_num:
                max_num = angar[i]
        if max_num >= 0: #если есть корабль, готовый к вылету (то есть прошёл цикл)
            angar[angar.index(max_num)] = 'nope'
        else: #иначе рейс задерживается
            delay += 1
        continue
    time += 1
    if time == 24:
        day += 1
        time = 0
    angar = increase(angar) #увеличиваем время стоянки кораблей на 1
x = len(angar) - angar.count('nope') #количество кораблей, проходящих цикл
print(out)
print(delay - x)