﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#define int long long
#define sz(x) (int)x.size()
#define forn(i, s, f) for(int i = 0; i < (int)f; ++i)

using namespace std;

const int inf = 1e9;

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    int ans1 = 0, ans2 = 0;
    vector<int> a(n, inf);
    vector<pair<int, int>> ev;
    while (k--) {
        int d, h, t;
        cin >> d >> h >> t;
        int v = (d - 1) * 24 + h;
        ev.push_back({ v, t });
    }
    sort(ev.begin(), ev.end());
    ev.push_back({ inf - 1, 0 });
    for (auto el : ev) {
        int v = el.first, t = el.second;
        sort(a.begin(), a.end());
        for (int i = 0; i < n && ans2; ++i) {
            if (a[i] <= v) {
                ans2--;
                a[i] = inf;
            }
        }
        sort(a.begin(), a.end());
        if (t == 1) {
            bool ok = 0;
            for (int i = 0; i < n; ++i) {
                if (a[i] == inf) {
                    a[i] = v + m * 24;
                    ok = 1;
                    break;
                }
            }
            if (!ok) ans1++;
        }
        else if (t == -1) {
            bool ok = 0;
            for (int i = 0; i < n; ++i) {
                if (a[i] <= v) {
                    a[i] = inf;
                    ok = 1;
                    break;
                }
            }
            if (!ok) ans2++;
        }
    }
    cout << ans1 << '\n' << ans2;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}