﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#define int long long
#define sz(x) (int)x.size()
#define forn(i, s, f) for(int i = 0; i < (int)f; ++i)

using namespace std;

const int inf = 1e9, N = 1e6 + 5;

/*

*/

void solve() {
    vector<bool> prime(N, 1);
    vector<int> pr;
    for (int i = 2; i < N; ++i) {
        if (prime[i]) {
            pr.push_back(i);
            for (int j = i * i; j < N; j += i) {
                prime[j] = 0;
            }
        }
    }
    int a, b;
    cin >> a >> b;
    int ans = inf, val = 0;
    for (int i = a; i <= b; ++i) {
        if (i % 2) continue;
        int g = 0;
        for (auto p : pr) {
            if (2 * p > i) break;
            if (prime[i - p]) g++;
        }
        if (g % 5 == 0) {
            if (ans == inf || g < ans) {
                ans = g;
                val = i;
            }
        }
    }
    if (ans == inf) cout << "Impossible";
    else cout << val << " " << ans;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}