#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

bool is_prime(int n) {
    for (int i = 2; i <= int(sqrt(n) + 1); ++i) {
        if (n % i == 0) {
            return false;
        }
    }
    return true;
}

int g(int n) {
    int total = 0;
    for (int i = 2; i <= n / 2; ++i) {
        int j = n - i;
        if (is_prime(i) && is_prime(j)) {
            total++;
        }
    }
    return total;
}

int main() {
    int a, b;
    cin >> a >> b;
    if (a % 2 == 1) {
        a++;
    }
    for (int i = a; i <= b; i += 2) {
        int cnt = g(i);
        if (cnt % 5 == 0) {
            cout << i << ' ' << cnt << endl;
            return 0;
        }
    }
    cout << "Impossible" << endl;
    return 0;
}
