#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main()
{
    ll a, b;
    cin >> a >> b;
    vector<bool> prime(b + 1, true);
    prime[0] = prime[1] = false;
    for (ll i = 2; i * i <= b; ++i) {
        if (prime[i]) {
            for (ll j = 2 * i; j <= b; j += i) {
                prime[j] = false;
            }
        }
    }
    vector<ll> pr;
    for (ll i = 0; i <= b; ++i) {
        if (prime[i]) {
            pr.push_back(i);
        }
    }
    vector<ll> g(b + 1);
    ll m = pr.size(), ans = -1;
    for (ll i = a; i <= b; ++i) {
        for (ll j = 0; j < m; ++j) {
            if (pr[j] * 2 > i) break;
            g[i] += (prime[i - pr[j]]);
        }
        if (!(i % 2) && !(g[i] % 5)) {
            ans = i;
            break;
        }
    }
    if (ans < 0) {
        cout << "Impossible";
    } else {
        cout << ans << " " << g[ans];
    }
    return 0;
}
