#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

typedef long long ll;

struct event {
    ll t, v, u, w;

    event(ll _t = 0, ll _v = 0, ll _u = 0, ll _w = 0) {
        t = _t, v = _v, u = _u, w = _w;
    }
};


int main()
{
    ll m;
    cin >> m;
    ll n = 105;
    vector<vector<ll> > g(m), g2(n);
    vector<ll> state(n), stateOut(m);
    vector<event> ev;
    for (ll i = 0; i + 1 < m; ++i) {
        ll cmd;
        cin >> cmd;
        if (!cmd) {
            ll x;
            cin >> x;
            cin >> state[x];
        } else if (cmd == 1) {
            ll v, u;
            cin >> v >> u;
            g[ev.size()].push_back(u);
            g2[u].push_back(ev.size());
            ev.push_back(event(cmd, v, u, -1));
        } else {
            ll v, u, w;
            cin >> v >> u >> w;
            g[ev.size()].push_back(w);
            g2[w].push_back(ev.size());
            ev.push_back(event(cmd, v, u, w));
        }
    }

    ll tmp, t, x;
    cin >> tmp >> x >> t;
    ll tme = 0, k = ev.size();
    while (tme < t) {
        ll c = ev[tme % k].t;
        if (c == 1) {
            stateOut[tme % k] = !state[ev[tme % k].v];
            state[ev[tme % k].u] = stateOut[tme % k];
        } else {
            stateOut[tme % k] = (state[ev[tme % k].u] && state[ev[tme % k].v]);
            state[ev[tme % k].w] = stateOut[tme % k];
        }
        if (stateOut[tme % k]) {
            for (ll i = 0; i < (ll)g[tme % k].size(); ++i) {
                state[g[tme % k][i]] = 1;
            }
        } else {
            for (ll i = 0; i < (ll)g[tme % k].size(); ++i) {
                vector<ll> tmp = g2[g[tme % k][i]];
                bool flag = false;
                for (ll j = 0; j < (ll)tmp.size(); ++j) {
                    flag |= stateOut[tmp[j]];
                }
                if (!flag) {
                    state[g[tme % k][i]] = 0;
                }
            }
        }
        cout << state[x] << '\n';
        ++tme;
    }
    return 0;
}
