#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

void print(vector<pair<int, int> > x){
    for (int i = 0; i < x.size(); ++i){
        cout << x[i].first << ' ' << x[i].second << endl;
    }
    cout << endl << endl;
}

int main(){
	int n, m, k;
	cin >> n >> m >> k;
	vector <pair<int, int> > ships;
	vector <pair<int, int> > departures;
	vector <pair<int, int> > garage;
	ll num_sp = 0, num_dp = 0;
	for (int i = 0; i < k; ++i){
        int day, hour, type;
        cin >> day >> hour >> type;
        if (type == 1) {
            ships.resize(ships.size() + 1);
            ships[ships.size() - 1].first = day;
            ships[ships.size() - 1].second = hour;
        }
        else {
            departures.resize(departures.size() + 1);
            departures[departures.size() - 1].first = day;
            departures[departures.size() - 1].second = hour;
        }
	}
	sort(ships.begin(), ships.end());
	sort(departures.begin(), departures.end());
	int last_day = max(ships[ships.size() - 1].first, departures[departures.size() - 1].first) + m + 1;
	cout << endl << last_day << endl;
	for (int day = 1; day <= last_day; ++day){
        print(ships);
        print(departures);
        print(garage);
        cout << endl;
        while(ships.size() > 0 && garage.size() < n){
            if (ships[0].first == day){
                garage.resize(garage.size() + 1);
                garage[garage.size() - 1].first = ships[0].first;
                garage[garage.size() - 1].second = ships[0].second;
                ships.erase(ships.begin());
            }
            else
                break;
        }
        while(departures.size() > 0 && departures[0].first <= day && garage.size() > 0){
            if (garage[0].first + m > day){
                break;
            }
            garage.erase(garage.begin());
            departures.erase(departures.begin());
        }
        while(ships.size() > 0 && garage.size() < n){
            if (ships[0].first == day){
                garage.resize(garage.size() + 1);
                garage[garage.size() - 1].first = ships[0].first;
                garage[garage.size() - 1].second = ships[0].second;
                ships.erase(ships.begin());
            }
            else
                break;
        }
        while(ships.size() > 0 && ships[0].first == day){
            num_sp++;
            ships.erase(ships.begin());
        }
	}
	print(ships);
    print(departures);
    print(garage);
	num_dp += departures.size();
	cout << num_sp << endl << num_dp << endl;
	return 0;
}
