// Generated at 2024.03.09 09:48:34
// Contest name - tinkoff - 24.03.09 швб
// Problem F

#include <iostream>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t; cin >> t;
    vector<pair<int, int>> p;
    vector<pair<pair<int, int>, int>> an;
    vector<pair<int, int>> no;
    vector<pair<int, int>> q;
    while (t--) {
        int c; cin >> c;
        if (c == 0) {
            int ind, st; cin >> ind >> st;
            p.push_back({ind, st});
        } else if (c == 1) {
            int a, b; cin >> a >> b;
            no.push_back({a, b});
        } else if (c == 2) {
            int a, b, c; cin >> a >> b >> c;
            an.push_back({{a, b}, c});
        } else {
            int a, b; cin >> a >> b;
            q.push_back({a, b});
        }
    }

    vector<vector<int>> points(60, vector<int>(p.size()));
    for (auto x : p) {
        points[0][x.first - 1] = x.second;
    }

    int n = p.size();
    vector<vector<pair<int, int>>> g(n);
    for (auto x : an) {
        g[x.second - 1].push_back({x.first.first, x.first.second});
    }

    for (auto x : no) {
        g[x.second - 1].push_back({-1, x.first});
    }

    for (int i = 1; i <= 55; ++i) {
        for (int j = 0; j < n; ++j) {
            if (g[j].empty()) {
                points[i][j] = points[i - 1][j];
                continue;
            }
            bool flag = false;
            for (auto x : g[j]) {
                if (x.first == -1) {
                    if (points[i - 1][x.second - 1] == 0) {
                        flag = true;
                    }
                } else {
                    if (points[i - 1][x.first - 1] == 1 && points[i - 1][x.second - 1] == 1) {
                        flag = true;
                    }
                }
            }

            if (flag) {
                points[i][j] = 1;
            } else {
                points[i][j] = 0;
            }
        }
    }

    for (auto x : q) {
        for (int i = 1; i <= x.second; ++i) {
            cout << points[i][x.first - 1] << '\n';
        }
    }
    return 0;
}
