

class NOT:
    def __init__(self, inp, out):
        self.inp = inp
        self.out = out

    def evaluate(self):
        return not points[self.inp]


class AND:
    def __init__(self, inp1, inp2, out):
        self.inp1 = inp1
        self.inp2 = inp2
        self.out = out

    def evaluate(self):
        return points[self.inp1] and points[self.inp2]


points = {}
elements = []

K = T = None


for _ in range(int(input())):
    task, *data = map(int, input().split())
    if task == 0:
        num, value = data
        points[num] = bool(value)
    elif task == 1:
        inp, out = data
        elements.append(NOT(inp, out))
    elif task == 2:
        inp1, inp2, out = data
        elements.append(AND(inp1, inp2, out))
    elif task == 3:
        K, T = data


for _ in range(T):
    new_points = {}
    for element in elements:
        if element.out not in new_points:
            new_points[element.out] = []
        new_points[element.out].append(element.evaluate())

    for num, values in new_points.items():
        points[num] = any(values)

    print(int(points[K]))


