#include "bits/stdc++.h"

using namespace std;

vector<bool> is_primes;
vector<int> primes;

void sieve(int max_n) {
    is_primes.resize(max_n+1, true);
    is_primes[1] = false;
    is_primes[0] = false;

    for (size_t i = 2; i <= max_n; i++)
    {
        if(!is_primes[i]) {
            continue;
        }

        int strt = i*2;

        while (strt <= max_n) 
        {
            is_primes[strt] = false;
            strt += i;
        }
    }
    
    for (size_t i = 0; i <= max_n; i++)
    {
        if(is_primes[i]) {
            primes.push_back(i);
        }
    }
    
}

int main() {
    int a, b;
   cin >> a >> b;

    sieve(b+1);

    for (size_t i = max(5,a); i <= b; i++)
    {
        if(i % 2 != 0) {
            continue;
        }
        

        int cur = 2;
        int cnt = 0;

        while (cur < primes.size() && primes[cur] <= (i-primes[cur]))
        {
            if (is_primes[(i - primes[cur])]) {
                cnt += 1;
            }
            cur++;
        }

        if (cnt % 5 == 0 && cnt > 0) {
            cout << i << " " << cnt << endl;
            return 0;
        }
    }

    cout << "Impossible" << endl;
    
}