
import sys

n, m, k = [int(i) for i in input().split()]
events = []

u = 0
for _ in range(k):
    d, h, et = [int(i) for i in input().split()]
    if et == 1:
        events.append((d, h, 1, u))
        events.append((d + m, h, -2, u))
        u += 1
    else:
        events.append((d, h, -1, -1))


events.sort(key=lambda x: (x[0] * 100 + x[1]) * 100 + x[2])
current_time = [0, 0]

ships = []

no_fix = 0
no_fly = 0

hold = 0

for event in events:
    current_time = [event[0], event[1]]
    event_type = event[2]
    ship = event[3]
    if event_type == 1:
        if len(ships) == n:
            no_fix += 1
            continue
        ships.append([ship, 0])
    if event_type == -2:
        for j in range(len(ships)):
            if ships[j][0] == ship:
                ships[j][1] = 1
                if hold > 0:
                    ships.pop(j)
                    hold -= 1
                break
    if event_type == -1:
        if sum(e[1] for e in ships) == 0:
            hold += 1
            continue
        for j in range(len(ships)):
            if ships[j][1] == 1:
                ships.pop(j)
                break

no_fly = hold

print(no_fix, no_fly, sep='\n')






'''
2 4 9
1 9 1
8 12 -1
6 15 -1
6 12 -1
2 18 1
5 6 1
6 12 1
7 12 -1
2 21 1
'''