// clang-format off
// #pragma GCC optimize("Ofast")
#include "vector"
#include "set"
#include "iostream"
#include "map"
#include "sstream"
#include "unordered_set"
#include "unordered_map"
#include "random"
#include "bitset"
#include "numeric"
#include "algorithm"
#include <chrono>
#include <thread>
#include <assert.h>

#ifdef LOCAL

#include "debug.h"

#endif
#ifndef LOCAL
#define debug(...)
#include "bits/stdc++.h"
#endif


typedef long long ll;
typedef long double ld;

#define int ll

#define vec vector
#define str string
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define pb push_back

static const int inf = 1e18, N = 1024 * 1024, mod1 = 1e9 + 7, mod2 = 1e9 + 9;

using namespace std;

void solve() {
    vec<bool> div(N, true);
    for (int i = 2; i < N; ++i) {
        for (int j = i * i; j < N; j += i) {
            div[j] = false;
        }
    }
    div[0] = false;
    div[1] = false;
    vec<int> primes;
    for (int i = 2; i < N; ++i) {
        if (div[i])primes.emplace_back(i);
    }
    int a, b;
    cin >> a >> b;
    bool flag = true;
    for (int i = a + a % 2; i <= b; i += 2) {
        int cnt = 0;
        for (auto j : primes) {
            if (j > i - j)break;
            if (div[i - j])cnt++;
        }
        if (cnt % 5 == 0) {
            cout << i << ' ' << cnt << endl;
            flag = false;
            break;
        }
    }
    if (flag)cout << "Impossible";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    //    cin >> tt;
    while (tt--)
        solve();

    return 0;
}
