// clang-format off
// #pragma GCC optimize("Ofast")
#include "vector"
#include "set"
#include "iostream"
#include "map"
#include "sstream"
#include "unordered_set"
#include "unordered_map"
#include "random"
#include "bitset"
#include "numeric"
#include "algorithm"
#include <chrono>
#include <thread>
#include <assert.h>

#ifdef LOCAL

#include "debug.h"

#endif
#ifndef LOCAL
#define debug(...)
#include "bits/stdc++.h"
#endif


typedef long long ll;
typedef long double ld;

#define int ll

#define vec vector
#define str string
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define pb push_back

static const int inf = 1e18, N = 1024 * 1024, mod1 = 1e9 + 7, mod2 = 1e9 + 9;

using namespace std;
struct rez {
    int type;
    int from1, from2;
    int to;
};

void solve() {
    int n;
    cin >> n;
    vec<int> cur(100);
    vec<rez> alls;
    int k = 0;
    int where = 0;
    vec<int> always_set(100, 1);
    for (int i = 0; i < n; ++i) {
        int type;
        cin >> type;
        if (type == 0) {
            int a, b;
            cin >> a >> b;
            a--;
            cur[a] = b;
        }
        if (type == 1) {
            rez a;
            a.type = 1;
            cin >> a.from1 >> a.to;
            a.from1--;
            a.to--;
            alls.emplace_back(a);
        }
        if (type == 2) {
            rez a;
            a.type = 2;
            cin >> a.from1 >> a.from2 >> a.to;
            a.from1--;
            a.from2--;
            a.to--;
            alls.emplace_back(a);
        }
        if (type == 3) {
            cin >> where >> k;
            where--;
        }
    }
    vec<int> copy = cur;
    for (auto x : alls) {
        always_set[x.to] = false;
    }
    for (int i = 0; i < k; ++i) {
        vec<int> to(100);
        for (int j = 0; j < 100; ++j) {
            if (always_set[j]) {
                to[j] = copy[j];
            }
        }
        for (auto &j : alls) {
            if (j.type == 1) {
                to[j.to] |= !cur[j.from1];
            }
            if (j.type == 2) {
                to[j.to] |= cur[j.from1] & cur[j.from2];
            }
        }
        cur = to;
        cout << cur[where] << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    //    cin >> tt;
    while (tt--)
        solve();

    return 0;
}
