from collections import deque

ships = deque()
reserved_ships = deque()
otkaz, otklon = 0, 0

garages, cycle, k = map(int, input().split())

journal = [tuple(map(int, input().split())) for _ in range(k)]
journal.sort(key=lambda x: x[0] * 240 + x[1] * 10 + x[2])

for day, hour, write_type in journal:
    now_time = day * 24 + hour
    while reserved_ships and now_time > reserved_ships[0]:
        reserved_ships.popleft()
    if write_type == 1:
        if len(ships) < garages:
            ships.append(now_time + cycle * 24)
        else:
            otkaz += 1
    elif write_type == -1:
        if not ships:
            otklon += 1
        elif ships[0] <= now_time:
            ships.popleft()
        elif ships[0] <= now_time + 24:
            reserved_ships.append(ships[0])
        else:
            otklon += 1

print(otkaz)
print(otklon)

