class And:
    def __init__(self, info: tuple):
        self._numb_type, *self.starts, self.end = info
        self.numb_type = 2

    def out_signal(self, in_state: list):
        state = all(in_state)
        return self.end, state


class Not:
    def __init__(self, info: tuple):
        self._numb_type, *self.starts, self.end = info
        self.numb_type = 1

    def out_signal(self, in_state: list):
        state = not in_state[0]
        return self.end, state


start_points = set()
states = dict()
elements = dict()
k, T, t = 0, 0, 0

for _ in range(int(input())):
    line = tuple(map(int, input().split()))
    if line[0] == 2:
        a = And(line)
        for start in a.starts:
            if elements.get(start):
                elements[start].append(a)
            else:
                elements[start] = [a]
    elif line[0] == 1:
        a = Not(line)
        start = a.starts[0]
        start_points.add(start)
        if elements.get(start):
            elements[start].append(a)
        else:
            elements[start] = [a]
    elif line[0] == 0:
        if line[2] == 1:
            states[line[1]] = True
            start_points.add(line[1])
        else:
            states[line[1]] = False
    elif line[0] == 3:
        k, T = line[1], line[2]

while t < T:
    new_states = states.copy()
    new_start_points = set()
    for point in start_points:
        for elem in elements[point]:
            end_point, value = elem.out_signal([states[start_point] for start_point in elem.starts])
            new_states[end_point] = value
            new_start_points.add(end_point)

    start_points = new_start_points
    states = new_states
    print(int(states[k]))
    t += 1