#include <iostream>
#include "vector"
#include "map"
#include "string"
#include "algorithm"
#include <set>
#include "queue"

#define int int64_t

using namespace std;

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    int n, m, k; cin >> n >> m >> k;
    vector<pair<int, int>> v (k);
    for (int i = 0; i < k; ++i) {
        int d, t; cin >> d >> t >> v[i].second;
        v[i].first = d * 24 + t;
    }
    std::sort(v.begin(), v.end());
    int otkaz = 0;
    queue<int> angar, ozhid;
    for (int i = 0; i < k; ++i) {
        while (!ozhid.empty() && v[i].first >= angar.front()) {
            angar.pop();
            ozhid.pop();
        }
        if (v[i].second == 1) {
            if (angar.empty() || angar.size() < n) angar.push(v[i].first + m * 24);
            else ++otkaz;
        } else {
            if (!angar.empty() && angar.front() <= v[i].first) angar.pop();
            else ozhid.push(v[i].first);
        }
    }
    cout << otkaz << '\n';
    if ((int)ozhid.size() > (int)angar.size()) cout << (int)ozhid.size() - (int)angar.size();
}